"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var redux_form_1 = require("redux-form");
var classNames = require("classnames");
var uuid = require("uuid");
var ace = require("brace");
var typings_1 = require("@amalto/typings");
var help_1 = require("@amalto/help");
require("brace/ext/searchbox");
require("brace/mode/csharp");
require("brace/mode/dockerfile");
require("brace/mode/groovy");
require("brace/mode/html");
require("brace/mode/java");
require("brace/mode/javascript");
require("brace/mode/json");
require("brace/mode/typescript");
require("brace/mode/tsx");
require("brace/mode/xml");
require("brace/mode/sql");
require("brace/theme/ambiance");
require("brace/theme/chaos");
require("brace/theme/chrome");
require("brace/theme/clouds");
require("brace/theme/clouds_midnight");
require("brace/theme/cobalt");
require("brace/theme/crimson_editor");
require("brace/theme/dawn");
require("brace/theme/dracula");
require("brace/theme/dreamweaver");
require("brace/theme/eclipse");
require("brace/theme/github");
require("brace/theme/gob");
require("brace/theme/gruvbox");
require("brace/theme/idle_fingers");
require("brace/theme/iplastic");
require("brace/theme/katzenmilch");
require("brace/theme/kr_theme");
require("brace/theme/kuroir");
require("brace/theme/merbivore");
require("brace/theme/merbivore_soft");
require("brace/theme/mono_industrial");
require("brace/theme/monokai");
require("brace/theme/pastel_on_dark");
require("brace/theme/solarized_dark");
require("brace/theme/solarized_light");
require("brace/theme/sqlserver");
require("brace/theme/terminal");
require("brace/theme/textmate");
require("brace/theme/tomorrow");
require("brace/theme/tomorrow_night");
require("brace/theme/tomorrow_night_blue");
require("brace/theme/tomorrow_night_bright");
require("brace/theme/tomorrow_night_eighties");
require("brace/theme/twilight");
require("brace/theme/vibrant_ink");
require("brace/theme/xcode");
var CodeEditorInput = (function (_super) {
    __extends(CodeEditorInput, _super);
    function CodeEditorInput(props) {
        var _this = _super.call(this, props) || this;
        _this._input = null;
        _this._meta = null;
        _this.renderCodeEditorInput = function (field) {
            var _a = _this.props, label = _a.label, help = _a.help, containerClass = _a.containerClass, inputClass = _a.inputClass, height = _a.height;
            var editorId = _this.state.editorId;
            _this._input = field.input;
            _this._meta = field.meta;
            return (React.createElement("div", { className: classNames('form-group', containerClass, {
                    'invalid': _this._meta.touched && !!_this._meta.error
                }) },
                label ? React.createElement("label", null,
                    label,
                    help && React.createElement(help_1.default, { text: help })) : null,
                React.createElement("div", { id: editorId, key: _this._input.name, className: classNames('form-control input-block', inputClass), style: height ? { height: height } : null }),
                (_this._meta.touched && !!_this._meta.error) && React.createElement("p", { className: "validation-error-message" }, _this._meta.error)));
        };
        _this.setEditorOptions = function (editor) {
            var userJson = _this.props.user ? typings_1.getUserJson(_this.props.user) : {};
            var userSettings = userJson ? userJson.codeEditorSettings || {} : {};
            var displaySettings = _this.props.displaySettings || {};
            editor.setTheme(displaySettings.theme || userSettings.theme || 'ace/theme/tomorrow_night_eighties');
            editor.setFontSize(displaySettings.fontSize || userSettings.fontSize || '12px');
            var showInvisibles = false;
            if (displaySettings.showInvisibles !== undefined) {
                showInvisibles = displaySettings.showInvisibles;
            }
            else if (userSettings.showInvisibles !== undefined) {
                showInvisibles = userSettings.showInvisibles;
            }
            editor.setShowInvisibles(showInvisibles);
            var showGutter = true;
            if (displaySettings.showGutter !== undefined) {
                showGutter = displaySettings.showGutter;
            }
            else if (userSettings.showGutter !== undefined) {
                showGutter = userSettings.showGutter;
            }
            editor.renderer.setShowGutter(showGutter);
            var wrap = false;
            if (displaySettings.wrap !== undefined) {
                wrap = displaySettings.wrap;
            }
            else if (userSettings.wrap !== undefined) {
                wrap = userSettings.wrap;
            }
            editor.getSession().setUseWrapMode(wrap);
            var showIndent = false;
            if (displaySettings.showIndent !== undefined) {
                showIndent = displaySettings.showIndent;
            }
            else if (userSettings.showIndent !== undefined) {
                showIndent = userSettings.showIndent;
            }
            editor.setDisplayIndentGuides(showIndent);
            if (_this.props.height) {
                editor.setOptions({
                    minLines: 1,
                    maxLines: null
                });
            }
            else {
                editor.setOptions({
                    minLines: 1,
                    maxLines: 20
                });
            }
            editor.renderer.setScrollMargin(8, 8, 0, 0);
            editor.clearSelection();
        };
        _this.getAceSession = function () {
            var session = _this.state.editorInstance.session;
            var filterHistory = function (deltas) { return deltas.filter(function (d) { return d.group !== "fold"; }); };
            return {
                selection: session.selection['toJSON'](),
                value: session.getValue(),
                history: {
                    undo: session['$undoManager'].$undoStack.map(filterHistory),
                    redo: session['$undoManager'].$redoStack.map(filterHistory)
                },
                scrollTop: session.getScrollTop(),
                scrollLeft: session.getScrollLeft(),
                options: session['getOptions']()
            };
        };
        _this.restoreSession = function (editor, session) {
            var copy = ace.createEditSession(session.value, undefined);
            copy['$undoManager'].$doc = copy;
            copy['$undoManager'].$undoStack = session.history.undo;
            copy['$undoManager'].$redoStack = session.history.redo;
            copy.setOptions(session.options);
            copy.setScrollTop(session.scrollTop);
            copy.setScrollLeft(session.scrollLeft);
            editor.setSession(copy);
            _this.setEditorOptions(editor);
            editor.$blockScrolling = Infinity;
            if (session.cursorPosition) {
                editor.selection.moveCursorToPosition(session.cursorPosition);
            }
            editor.focus();
            editor.setShowPrintMargin(false);
        };
        _this.isSessionSavable = function (editor) {
            var annotations = editor.getSession().getAnnotations();
            var isSavable = true;
            if (annotations.length === 0) {
                isSavable = true;
            }
            else {
                annotations.forEach(function (a) {
                    isSavable = a.type === 'error' ? false : isSavable;
                });
            }
            return isSavable;
        };
        _this.editorOnChange = function (e) {
            var initSession = _this.props.initSession;
            var editor = _this.state.editorInstance;
            if (initSession) {
                initSession.cursorPosition = e.end;
                initSession.value = editor.getValue();
            }
            _this._input.onChange(editor.getValue(), undefined);
        };
        _this.state = {
            editorId: uuid.v4()
        };
        return _this;
    }
    CodeEditorInput.prototype.render = function () {
        var _a = this.props, format = _a.format, normalize = _a.normalize, parse = _a.parse, validate = _a.validate, warn = _a.warn;
        var baseFieldProps = {
            name: name,
            format: format,
            normalize: normalize,
            parse: parse,
            validate: validate,
            warn: warn
        };
        return React.createElement(redux_form_1.Field, __assign({}, baseFieldProps, { component: this.renderCodeEditorInput }));
    };
    CodeEditorInput.prototype.componentDidMount = function () {
        var _this = this;
        this.setState({
            editorInstance: ace.edit(this.state.editorId)
        }, function () {
            var _a = _this.props, mode = _a.mode, readonly = _a.readonly, initSession = _a.initSession;
            var editor = _this.state.editorInstance;
            editor.getSession().setUndoManager(new ace.UndoManager());
            editor.$blockScrolling = Infinity;
            if (_this.props.initialValues) {
                editor.setValue(_this.props.initialValues[_this.props.name]);
            }
            if (_this._input.value) {
                editor.setValue(_this._input.value);
            }
            if (initSession) {
                _this.restoreSession(editor, initSession);
            }
            editor.getSession().setMode(mode || 'ace/mode/javascript');
            editor.setShowPrintMargin(false);
            editor.setReadOnly(readonly);
            _this.setEditorOptions(editor);
            _this.props.saveSession && _this.props.saveSession($.extend({}, _this.getAceSession(), {
                savable: _this.isSessionSavable(editor)
            }));
            editor.commands.addCommand({
                name: 'save',
                bindKey: { win: 'Ctrl-S', mac: 'Command-S' },
                exec: function (currentEditor) {
                    _this.props.saveEditorContent && _this.props.saveEditorContent($.extend({}, initSession, {
                        savable: _this.isSessionSavable(currentEditor),
                        cursorPosition: currentEditor.getCursorPosition()
                    }));
                }
            });
            editor.commands.addCommand({
                name: 'save all',
                bindKey: { win: 'Shift-Ctrl-S', mac: 'Shift-Command-S' },
                exec: function (currentEditor) {
                    _this.props.saveMultipleContent && _this.props.saveMultipleContent($.extend({}, initSession, {
                        savable: _this.isSessionSavable(currentEditor),
                        cursorPosition: currentEditor.getCursorPosition()
                    }));
                }
            });
            editor.on('change', _this.editorOnChange);
        });
    };
    CodeEditorInput.prototype.componentDidUpdate = function (prevProps) {
        var editorInstance = this.state.editorInstance;
        var _a = this.props, readonly = _a.readonly, displaySettings = _a.displaySettings, height = _a.height;
        if (editorInstance) {
            if (prevProps.readonly !== readonly) {
                editorInstance.setReadOnly(readonly);
            }
            if (prevProps.displaySettings !== displaySettings) {
                this.setEditorOptions(editorInstance);
            }
            if (prevProps.height !== height) {
                this.setEditorOptions(editorInstance);
            }
            if (prevProps.resetTick !== this.props.resetTick) {
                editorInstance.setValue(this._input && this._input.value);
                editorInstance.clearSelection();
            }
        }
    };
    CodeEditorInput.prototype.componentWillUnmount = function () {
        var saveSession = this.props.saveSession;
        var editorInstance = this.state.editorInstance;
        if (saveSession && editorInstance) {
            saveSession(this.getAceSession());
        }
        if (editorInstance) {
            editorInstance.removeListener('change', this.editorOnChange);
            editorInstance.destroy();
        }
    };
    return CodeEditorInput;
}(React.Component));
exports.default = CodeEditorInput;
//# sourceMappingURL=index.js.map